;2011/06
;Music by DMA-SC/sector 1
;Graphics by Ukko/Live!
;Code by Ukko/Live! and baah/(Arm's Tech + positivity)
;(Help from Zekman/Sector One and Paradox)

  opt o+

TimeCredits=60
TimeTitle=420  
TimeImage1=300
TimeTrans1=20
TimeText1=300
TimeImage2=300
TimeTrans2=30
TimeText2=325
TimeImage3=300
TimeTrans3=30
TimeText3=325
TimeImage4=275
TimeTrans4=30
TimeText4=275 ;***
TimeTube5=0
TimeEndPic=300
  
;*******************************
;****    INITIALISATIONS    ****
;*******************************
  clr.l     -(sp)
  move.w    #32,-(sp)           ;Switch to supervisor
  trap      #1
  addq.l    #2,sp
    
;Save old config
  lea       OldConfig,a6
  move.w    #3,-(sp)            ;Get LogBase in d0.l 
  trap      #14
  addq.l    #2,sp
  move.l    d0,(a6)+
;  move.l    $ffff8200.w,(a6)+     ;@vram
  move.b    $ffff820a.w,(a6)+     ;frequency
  move.b    $ffff8260.w,(a6)+     ;resolution
  move.l    $68.w,(a6)+           ;HBL
  move.l    $70.w,(a6)+           ;VBL
  move.l    $120.w,(a6)+          ;Timer B (HBL)
  move.l    $134.w,(a6)+          ;Timer A
  move.b    $fffffa07.w,(a6)+     ;IERA
  move.b    $fffffa09.w,(a6)+     ;IERB
;  move.b    $fffffa13.w,(a6)+     ;IMRA=Interrupt Mask A
  movem.l   $ffff8240.w,d0-d7     ;Colors
  movem.l   d0-d7,(a6)
;STOP MOUSE  
  dc.w      $a00a
  move.b    #18,$fffffc02.w
  
;*************************************
;****    CREATE ADRESSES TABLE    ****
;*************************************
  move.l    VideoRamAdress,a5
  move.l    #TitlePic+34,d0
  move.b    #0,d0               ;Align Screen1 on a multiple of 256
  move.l    a5,ScreenAdresses
  move.l    d0,ScreenAdresses+4
 
  
;********************
;****    DEMO    ****
;********************
  
;INIT MUSIC AND DUMB VBL + BLACK + 320*200
  jsr       Music
  move.l    #Dumb_VBL,$70.w
  lea       BlackPalette,a1
  jsr       Fade
  move.w    #1,d7
  jsr       Wait
  move.b    #0,$ffff8260.w      ;Switch to 320*200*4bpp
;CLEAR VRAM
  move.l    ScreenAdresses,a6
  moveq.l   #0,d0
  move.w    #7999,d1
ClearVramFirstLoop  
  move.l    d0,(a6)+
  dbra      d1,ClearVramFirstLoop
;CREDITS
  lea       Credits1,a5
  move.l    ScreenAdresses,a6
  addq.l    #4,a6
  jsr       Print
  lea       BlackTextPalette,a1
  jsr       Fade
  move.w    #TimeCredits,d7
  jsr       Wait
  lea       BlackPalette,a1
  jsr       Fade
  lea       Credits2,a5
  move.l    ScreenAdresses,a6
  addq.l    #4,a6
  jsr       Print
  lea       BlackTextPalette,a1
  jsr       Fade
  move.w    #TimeCredits,d7
  jsr       Wait
  lea       BlackPalette,a1
  jsr       Fade
  lea       Credits3,a5
  move.l    ScreenAdresses,a6
  addq.l    #4,a6
  jsr       Print
  lea       BlackTextPalette,a1
  jsr       Fade
  move.w    #TimeCredits,d7
  jsr       Wait
  lea       BlackPalette,a1
  jsr       Fade
;ARNOLD
  move.l    VideoRamAdress,a5
  lea       TitlePic+34,a6
  move.w    #8000-1,d0
CopyTitlePicToVideoRam
  move.l    (a6)+,(a5)+
  dbra      d0,CopyTitlePicToVideoRam
  lea       TitlePic+2,a1
  jsr       Fade
;  move.b    #1,VBL_FlashOnOff
  move.w    #TimeTitle,d7
  jsr       Wait
;  clr.b     VBL_FlashOnOff
  lea       RedPalette,a1
  jsr       Fade
;TUBE+IMG1+RED
  jsr       ClearAll
  move.l    #TUBE_VBL,$70.w
  lea       TubeRedPalette,a1
  jsr       Fade
  lea       Image1,a0
  jsr       CopyImage
  lea       TubeImageRedPalette,a1
  jsr       Fade
;  move.b    #1,VBL_FlashOnOff
  move.w    #TimeImage1,d7
  jsr       Wait
;  clr.b     VBL_FlashOnOff
;TUBE+RED
  lea       TubeRedPalette,a1
  jsr       Fade
  jsr       ClearImage
  move.w    #TimeTrans1,d7
  jsr       Wait
;TUBE+TEXT+RED  
  lea       Text1,a5
  jsr       MakeText
  lea       TubeTextRedPalette,a1
  jsr       Fade
  move.w    #TimeText1,d7
  jsr       Wait
  lea       TubeRedPalette,a1
  jsr       Fade
  jsr       ClearImage
  lea       RedPalette,a1
  jsr       Fade
;LAVA+IMG2+GREEN   
  lea       GreenPalette,a1
  jsr       Fade
  move.l    #LAVA_VBL,$70.w
  jsr       ClearAll
  lea       LavaGreenPalette,a1
  jsr       Fade
  lea       Image2,a0
  jsr       CopyImage
  lea       LavaImageGreenPalette,a1
  jsr       Fade
  move.w    #TimeImage2,d7
  jsr       Wait
;LAVA+GREEN
  lea       LavaGreenPalette,a1
  jsr       Fade
  jsr       ClearImage
  move.w    #TimeTrans2,d7
  jsr       Wait
;LAVA+TEXT2+GREEN
  lea       Text2,a5
  jsr       MakeText
  lea       LavaTextGreenPalette,a1
  jsr       Fade
  move.w    #TimeText2,d7
  jsr       Wait
  lea       GreenPalette,a1
  jsr       Fade
;TUBE+IMG3+BLUE
  lea       BluePalette,a1
  jsr       Fade
  move.l    #TUBE_VBL,$70.w
  jsr       ClearAll
  lea       Image3,a0
  jsr       CopyImage
  lea       TubeImageBluePalette,a1
  jsr       Fade
  move.w    #TimeImage3,d7
  jsr       Wait
  lea       TubeBluePalette,a1
  jsr       Fade
  jsr       ClearImage
;TUBE+BLUE
  lea       TubeBluePalette,a1
  jsr       Fade
  jsr       ClearImage
  move.w    #TimeTrans3,d7
  jsr       Wait
;TUBE+TEXT+BLUE  
  lea       Text3,a5
  jsr       MakeText
  lea       TubeTextBluePalette,a1
  jsr       Fade
  move.w    #TimeText3,d7
  jsr       Wait
  lea       TubeBluePalette,a1
  jsr       Fade
  jsr       ClearImage
  lea       BluePalette,a1
  jsr       Fade
;LAVA+IMG4+GREEN   
  lea       GreenPalette,a1
  jsr       Fade
  move.l    #LAVA_VBL,$70.w
  jsr       ClearAll
  lea       LavaGreenPalette,a1
  jsr       Fade
  lea       Image4,a0
  jsr       CopyImage
;  lea       LavaOutlineGreenPalette,a1
  lea       LavaImageGreenPalette,a1
  jsr       Fade
  move.w    #TimeImage4,d7
  jsr       Wait
;LAVA+GREEN
  lea       LavaGreenPalette,a1
  jsr       Fade
  jsr       ClearImage
  move.w    #TimeTrans4,d7
  jsr       Wait
;LAVA+TEXT4+GREEN
  lea       Text4,a5
  jsr       MakeText
  lea       LavaTextGreenPalette,a1
  jsr       Fade
  move.w    #TimeText4,d7
  jsr       Wait
  lea       LavaGreenPalette,a1
  jsr       Fade
  jsr       ClearImage
  lea       GreenPalette,a1
  jsr       Fade
;TUBE+BLUE
  lea       RedPalette,a1
  jsr       Fade
  move.l    #TUBE_VBL,$70.w
  jsr       ClearAll
  lea       Image4,a0
  jsr       CopyImage         ;BUG
  jsr       ClearImage
  lea       TubeImageRedPalette,a1
  jsr       Fade
  move.w    #TimeTube5,d7
  jsr       Wait
;END  
  lea       WhitePalette,a1
  jsr       SlowFade
  jsr       ClearAll
;END PIC
  move.l    #Dumb_VBL,$70.w
;MADLAB
  move.l    ScreenAdresses,a4
  move.l    ScreenAdresses+4,a5
  lea       EndPic+34,a6
  move.w    #8000-1,d0
CopyEndPicToVideoRam
  move.l    (a6)+,d1
  move.l    d1,(a4)+
  move.l    d1,(a5)+
  dbra      d0,CopyEndPicToVideoRam
  lea       EndPic+2,a1
  jsr       MidFade
  
  jsr       Music+4

  move.w    #TimeEndPic,d7
  jsr       Wait
  lea       BlackPalette,a1
  jsr       Fade
  jsr       ClearAll
  lea       WhitePalette,a1
  jsr       Fade
  
;****************************
;****    RESTORATIONS    ****
;****************************  
  

  move  #$2700,sr
  clr.b  $fffffa19.w
  clr.b  $ffff820a.w

;RESTORE MOUSE
  move.b    #8,$fffffc02.w
  dc.w      $a009
  
  lea       OldConfig,a6
  move.l    (a6)+,d0
  lsr.w     #8,d0               ;Set video shifter
  move.b    d0,$ffff8203.w
  swap.w    d0
  move.b    d0,$ffff8201.w
  move.b    (a6)+,$ffff820a.w     ;frequency
  move.b    (a6)+,$ffff8260.w     ;resolution
  move.l    (a6)+,$68.w           ;HBL
  move.l    (a6)+,$70.w           ;VBL
  move.l    (a6)+,$120.w          ;Timer B (HBL)
  move.l    (a6)+,$134.w          ;Timer A
  move.b    (a6)+,$fffffa07.w     ;IERA
  move.b    (a6)+,$fffffa09.w     ;IERB
;  move.b    (a6)+,$fffffa13.w     ;IMRA=Interrupt Mask A
  movem.l   (a6),d0-d7
  movem.l   d0-d7,$ffff8240.w     ;Colors

;TERMINATE
  clr.w     -(sp)
  trap      #1

  
  
;*******************
;****    VBL    ****
;*******************

Dumb_VBL
  addq.l    #$1,$466.w  ; Increase _frclock.
  move.b    #1,VBL_Flag
  movem.l   d0-d7/a0-a6,-(sp)
;Change palette
  lea       PaletteToCopyOnVBL,a0
  movem.l   (a0),d0-d7
  lea       $ffff8240.w,a0
  movem.l   d0-d7,(a0)
;Music    
  jsr       Music+8
  move.b    Music+$b8,d0
  tst.b     d0
  beq.s     .NoMusicSync
  move.b    #3,VBL_FlashCounter
.NoMusicSync  
  clr.b     Music+$b8
  move.b    VBL_FlashCounter,d0
  subq.b    #1,d0
  ble.s     NoMusicFlash
  move.b    d0,VBL_FlashCounter
  tst.b     VBL_FlashOnOff
  beq.s     NoMusicFlash
  add.w     #$111,$ffff8240.w  
NoMusicFlash  
  movem.l   (sp)+,d0-d7/a0-a6
  rte
  
TUBE_VBL
  addq.l    #$1,$466.w  ; Increase _frclock.
  move.b    #1,VBL_Flag
  movem.l   d0-d7/a0-a6,-(sp)
;Change palette
  lea       PaletteToCopyOnVBL,a0
  movem.l   (a0),d0-d7
  lea       $ffff8240.w,a0
  movem.l   d0-d7,(a0)
  
;Music    
  jsr       Music+8
  move.b    Music+$b8,d0
  tst.b     d0
  beq.s     .NoMusicSync
  move.b    #3,VBL_FlashCounter
.NoMusicSync  
  clr.b     Music+$b8
  move.b    VBL_FlashCounter,d0
  subq.b    #1,d0
  ble.s     NoMusicFlashTube
  move.b    d0,VBL_FlashCounter
  tst.b     VBL_FlashOnOff
  beq.s     NoMusicFlashTube
  add.w     #$111,$ffff8240.w  
NoMusicFlashTube  
;Exchange screen adresses
  lea       ScreenAdresses,a0
  move.l    (a0)+,a6
  move.l    (a0),-4(a0)
  move.l    a6,(a0)
  move.l    a6,d0
  lsr.w     #8,d0               ;Set video shifter
  move.b    d0,$ffff8203.w
  swap.w    d0
  move.b    d0,$ffff8201.w
  add.w     #32,a6
;  move.w    #$556,$ffff8240.w ;!!!
  jsr       DrawTube
;  move.w    #$000,$ffff8240.w ;!!!
  movem.l   (sp)+,d0-d7/a0-a6
  rte

VBL_FlashCounter: dc.b      0
VBL_FlashOnOff:   dc.b      0  
  
LAVA_VBL
  addq.l    #$1,$466.w  ; Increase _frclock.
  move.b    #1,VBL_Flag
  movem.l   d0-d7/a0-a6,-(sp)
;Change palette
  lea       PaletteToCopyOnVBL,a0
  movem.l   (a0),d0-d7
  lea       $ffff8240.w,a0
  movem.l   d0-d7,(a0)
;Music    
  jsr       Music+8
  move.b    Music+$b8,d0
  tst.b     d0
  beq.s     .NoMusicSync
  move.b    #3,VBL_FlashCounter
.NoMusicSync  
  clr.b     Music+$b8
  move.b    VBL_FlashCounter,d0
  subq.b    #1,d0
  ble.s     NoMusicFlashLava
  move.b    d0,VBL_FlashCounter
  tst.b     VBL_FlashOnOff
  beq.s     NoMusicFlashLava
  add.w     #$111,$ffff8240.w  
NoMusicFlashLava 
;Exchange screen adresses
  lea       ScreenAdresses,a0
  move.l    (a0)+,a6
  move.l    (a0),-4(a0)
  move.l    a6,(a0)
  move.l    a6,d0
  lsr.w     #8,d0               ;Set video shifter
  move.b    d0,$ffff8203.w
  swap.w    d0
  move.b    d0,$ffff8201.w
;  move.w    #$667,$ffff8240.w ;!!!
  jsr       DrawLava
;  move.w    #$556,$ffff8240.w ;!!!
  movem.l   (sp)+,d0-d7/a0-a6
  rte


  
VBL_Flag
  dc.w    0

;*************************
;****    MAKE TEXT    ****
;*************************
;IN  a5=@text
MakeText
  lea       ScreenAdresses,a0
  movem.l   (a0),a1/a6
  addq.l    #4,a6
  jsr       Print
  move.l    a1,a6
  addq.l    #4,a6
  jsr       Print
  rts

;*********************
;****    PRINT    ****
;*********************
;IN  a6.l=@vram
;    a5.l=@text (ALL lines finished by 0, page finished by 255)
  include 'SUPRSTAR\PRINT.S'

;**************************
;****    COPY IMAGE    ****
;**************************
;IN  a0=@two bitplane image
CopyImage
  lea       ScreenAdresses,a1
  move.l    (a1)+,a2
  move.l    (a1)+,a3
  move.w    #3999,d0
;  moveq.l   #0,d1
CopyImageLoop
;  move.l    d1,(a2)+
;  move.l    d1,(a3)+
  addq.l    #4,a2
  addq.l    #4,a3
  move.l    (a0)+,d2
  move.l    d2,(a2)+
  move.l    d2,(a3)+
  dbra      d0,CopyImageLoop
  rts

;***************************
;****    CLEAR IMAGE    ****
;***************************
ClearImage
  lea       ScreenAdresses,a1
  move.l    (a1)+,a2
  move.l    (a1)+,a3
  move.w    #3999,d0
  moveq.l   #0,d1
ClearImageLoop
  addq.l    #4,a2
  addq.l    #4,a3
  move.l    d1,(a2)+
  move.l    d1,(a3)+
  dbra      d0,ClearImageLoop
  rts

;*************************
;****    CLEAR ALL    ****
;*************************
ClearAll
  lea       ScreenAdresses,a1
  move.l    (a1)+,a2
  move.l    (a1)+,a3
  move.w    #7999,d0
  moveq.l   #0,d1
ClearAllLoop
  move.l    d1,(a2)+
  move.l    d1,(a3)+
  dbra      d0,ClearAllLoop
  rts
  
;********************
;****    WAIT    ****
;********************
;IN  d7=Nb VBLs to wait
Wait
  tst.b     VBL_Flag
  beq.s     Wait
  move.b    #0,VBL_Flag
  dbra d7,Wait
  rts

;********************
;****    FADE    ****
;********************
;IN  a1: palette to fade to
Fade
  lea       $ffff8240.w,a0
  lea       FadePalette,a2
  move.l    a2,a6
  bsr       MKFADE
  lea       PaletteToCopyOnVBL,a5
  move.w    #32,d7
FadeLoop  
  tst.b     VBL_Flag
  beq.s     FadeLoop
  move.b    #0,VBL_Flag
  movem.l   (a6)+,d0-d6/a0
  movem.l   d0-d6/a0,(a5)
  dbra      d7,FadeLoop
  rts

;************************
;****    SLOWFADE    ****
;************************
;IN  a1: palette to fade to
NbVBLs_SlowFade=14

SlowFade
  lea       $ffff8240.w,a0
  lea       FadePalette,a2
  move.l    a2,a6
  bsr.s     MKFADE
  add.w     #128,a6
  lea       PaletteToCopyOnVBL,a5
  move.w    #28,d7
SlowFadeLoop  
  move.w    #NbVBLs_SlowFade,d6
SlowFadeOneVBL
  tst.b     VBL_Flag
  beq.s     SlowFadeOneVBL
  move.b    #0,VBL_Flag
  subq.w    #1,d6
  bne.s     SlowFadeOneVBL
  
  movem.l   (a6)+,d0-d6/a0
  movem.l   d0-d6/a0,(a5)
  dbra      d7,SlowFadeLoop
  rts

;***********************
;****    MIDFADE    ****
;***********************
;IN  a1: palette to fade to
NbVBLs_MidFade=2

MidFade
  lea       $ffff8240.w,a0
  lea       FadePalette,a2
  move.l    a2,a6
  bsr.s     MKFADE
  lea       PaletteToCopyOnVBL,a5
  move.w    #32,d7
MidFadeLoop  
  move.w    #NbVBLs_MidFade,d6
MidFadeOneVBL
  tst.b     VBL_Flag
  beq.s     MidFadeOneVBL
  move.b    #0,VBL_Flag
  subq.w    #1,d6
  bne.s     MidFadeOneVBL
  
  movem.l   (a6)+,d0-d6/a0
  movem.l   d0-d6/a0,(a5)
  dbra      d7,MidFadeLoop
  rts
  
  
  
;***********************
;****    MK FADE    ****
;***********************
;a0=@src palette
;a1=@dest palette
;a2=@storage for 33 palettes (33*16*2 bytes)
;KILLS d0-d7,a0-a4
  include 'SUPRSTAR\MKFADE.S'
  
  
;*************************
;****    DRAW TUBE    ****
;*************************
;IN:  a6=@VRAM
;OUT: KILLS EVERYTHING
DrawTube:
  include 'SUPRSTAR\DRAWTUBE.S'  
 
  
  
;*************************
;****    DRAW LAVA    ****
;*************************
;IN:  a6=@VRAM
;OUT: KILLS EVERYTHING
DrawLava:
     move.w   #4095,d7
     lea      LavaTexture,a4
     lea      LavaSin,a5
     addq.w    #6,Lava_a
     and.w    d7,Lava_a
     move.w   Lava_a,d0
     add.w    #256,d0
     move.w   d0,Lava_b
     move.l   #0,a1
    rept 199
        
        addq.w #4,a1
      
        move.w Lava_a,d0
        add.w  a1,d0
        and.w d7,d0
        
        move.w (a5,d0),a3   ;sin Lava_a

        add.w #20,Lava_b
        and.w d7,Lava_b
        move.w Lava_b,d0

        add.w (a5,d0),a3
        add.l   a3,a3
        add.l   a4,a3

        movem.l (a3)+,D0-D6/a2
        move.l d0,16(a6) 
        move.l d1,24(a6) 
        move.l d2,32(a6) 
        move.l d3,40(a6) 
        move.l d4,48(a6) 
        move.l d5,56(a6) 
        move.l d6,64(a6)
        move.l a2,72(a6)  
        movem.l (a3)+,D0-D6/a2
        move.l d0,80(a6) 
        move.l d1,88(a6) 
        move.l d2,96(a6) 
        move.l d3,104(a6) 
        move.l d4,112(a6) 
        move.l d5,120(a6) 
        move.l d6,128(a6) 
        move.l a2,136(a6) 
        add.l #160,a6
        

    ENDR  

  rts
  
;********************
;****    DATA    ****
;********************


PaletteToCopyOnVBL:  dc.w  0,$777,0,$777,0,$777,0,$777,0,$777,0,$777,0,$777,0,$777
BlackPalette: dc.w  0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
BlackTextPalette: dc.w  0,0,0,0,$667,$667,$667,$667,$445,$445,$445,$445,$222,$222,$222,$222
;BlackWhitePalette:  dc.w 0,$777,$777,$777,$777,$777,$777,$777,$777,$777,$777,$777,$777,$777,$777,$777
WhitePalette:  dc.w $777,$777,$777,$777,$777,$777,$777,$777,$777,$777,$777,$777,$777,$777,$777,$777

TubeBluePalette:       dc.w $556,$667,$334,$445,$556,$667,$334,$445,$556,$667,$334,$445,$556,$667,$334,$445
BluePalette:           dc.w $556,$556,$556,$556,$556,$556,$556,$556,$556,$556,$556,$556,$556,$556,$556,$556
TubeTextBluePalette:   dc.w $556,$667,$334,$445,$000,$000,$000,$000,$222,$222,$222,$222,$445,$445,$445,$445
TubeImageBluePalette:  dc.w $556,$667,$334,$445,$000,$000,$000,$000,$333,$333,$333,$333,$777,$777,$777,$777

TubeRedPalette:        dc.w $565,$676,$343,$454,$565,$676,$343,$454,$565,$676,$343,$454,$565,$676,$343,$454
RedPalette:            dc.w $565,$565,$565,$565,$565,$565,$565,$565,$565,$565,$565,$565,$565,$565,$565,$565
TubeTextRedPalette:    dc.w $565,$676,$343,$454,$000,$000,$000,$000,$222,$222,$222,$222,$454,$454,$454,$454
TubeImageRedPalette:   dc.w $565,$676,$343,$454,$000,$000,$000,$000,$333,$333,$333,$333,$777,$777,$777,$777

LavaGreenPalette:      dc.w $645,$746,$757,$767,$645,$746,$757,$767,$645,$746,$757,$767,$645,$746,$757,$767
GreenPalette           dc.w $645,$645,$645,$645,$645,$645,$645,$645,$645,$645,$645,$645,$645,$645,$645,$645
LavaTextGreenPalette:  dc.w $645,$746,$757,$767,$000,$000,$000,$000,$222,$222,$222,$222,$544,$544,$544,$544
LavaImageGreenPalette: dc.w $645,$746,$757,$767,$000,$000,$000,$000,$333,$333,$333,$333,$777,$777,$777,$777
;LavaOutlineGreenPalette: dc.w $645,$746,$757,$767,$222,$222,$222,$222,$555,$555,$555,$555,$777,$777,$777,$777
  
ScreenAdresses
  dc.l 0      ;@workscreen
  dc.l 0      ;@showscreen

OldConfig
VideoRamAdress: ds.l  1
Frequency: ds.b 1
Resolution: ds.b 1
HBlVector: ds.l 1
VBLVector: ds.l 1
TimerAVector: ds.l 1
TimerBVector: ds.l 1
IERA: ds.b 1
IERB: ds.b 1
colors: ds.w 16
  
Music:      incbin 'SUPRSTAR\OL11BU07.SND'

  ds.b 256-34     ;for alignement
TitlePic:      incbin 'SUPRSTAR\ARNOLD.PI1'

Image1:      incbin 'SUPRSTAR\IMAGE1.XXX'
Image2:      incbin 'SUPRSTAR\IMAGE2.XXX'
Image3:      incbin 'SUPRSTAR\IMAGE3.XXX'
Image4:      incbin 'SUPRSTAR\IMAGE4.XXX'

EndPic:      incbin 'SUPRSTAR\MADLAB.PI1'

Credits1: dc.b 0,'Ukko',0,0,0,0,0,0,255
Credits2: dc.b 0,'Ukko',0,'&',0,'Dma-Sc',0,0,0,0,255
Credits3: dc.b 0,'Ukko',0,'&',0,'Dma-Sc',0,'&',0,'baah',0,0,255

Text1:
 dc.b 'Welcome to',0
 dc.b 'the SuperStar Island',0
 dc.b '',0
 dc.b 'I will be your host',0
 dc.b 'for the day',0
 dc.b '',0
 dc.b 'Be prepared for',0
 dc.b 'some fantastic moments',0
 dc.b 255
Text2:
 dc.b 'The Sensei is here',0
 dc.b '',0
 dc.b 'Listen carefully to his advice',0
 dc.b '',0
 dc.b 'It will change your life',0
 dc.b 'and make you a better man',0
 dc.b '',0
 dc.b 'I know I am...',0
 dc.b 255
Text3:
 dc.b 'If you have any problem...',0
 dc.b '',0
 dc.b '...just call us',0
 dc.b '',0
 dc.b 'There''s nothing',0
 dc.b 'we cannot cope with',0
 dc.b '',0
 dc.b 'Except deadlines maybe...',0
 dc.b 255
Text4:
 dc.b 'Outline organisers',0
 dc.b 'BASS / Beetle / Checkpoint',0
 dc.b 'Cyclone / DHS /DNT Crew / Dune',0
 dc.b 'Elf / Equinox / Exocet / kUa',0
 dc.b 'Hemoroids / IceBirD / LineOut /OXG',0
 dc.b 'Paradox / Razor 1911 / Reboot',0
 dc.b 'Reservoir Gods / Tinker / .tSCc.',0
 dc.b 'XiA / Ym Rockerz / Zuul',0
 dc.b '... we Love You!',0
 dc.b 255

 EVEN
 
LavaTexture:      Incbin 'SUPRSTAR\LAVA.XXX'

LavaSin:
    dc.w    480,480,480,512,512,512,512,512,512,544,544,544,544,544,576,576,576,576,576,576,608,608,608,608,608,640,640,640,640,640,640,672
    dc.w    672,672,672,672,672,704,704,704,704,704,704,736,736,736,736,736,736,736,768,768,768,768,768,768,800,800,800,800,800,800,800,800
    dc.w    832,832,832,832,832,832,832,832,864,864,864,864,864,864,864,864,864,896,896,896,896,896,896,896,896,896,896,896,928,928,928,928
    dc.w    928,928,928,928,928,928,928,928,928,928,928,960,960,960,960,960,960,960,960,960,960,960,960,960,960,960,960,960,960,960,960,960
    dc.w    960,960,960,960,960,960,960,960,960,960,960,960,960,960,960,960,960,960,960,960,960,960,928,928,928,928,928,928,928,928,928,928
    dc.w    928,928,928,928,928,896,896,896,896,896,896,896,896,896,896,896,864,864,864,864,864,864,864,864,864,832,832,832,832,832,832,832
    dc.w    832,800,800,800,800,800,800,800,800,768,768,768,768,768,768,736,736,736,736,736,736,736,704,704,704,704,704,704,672,672,672,672
    dc.w    672,672,640,640,640,640,640,640,608,608,608,608,608,576,576,576,576,576,576,544,544,544,544,544,512,512,512,512,512,512,480,480
    dc.w    480,480,480,448,448,448,448,448,448,416,416,416,416,416,384,384,384,384,384,384,352,352,352,352,352,320,320,320,320,320,320,288
    dc.w    288,288,288,288,288,256,256,256,256,256,256,224,224,224,224,224,224,224,192,192,192,192,192,192,160,160,160,160,160,160,160,160
    dc.w    128,128,128,128,128,128,128,128,96,96,96,96,96,96,96,96,96,64,64,64,64,64,64,64,64,64,64,64,32,32,32,32
    dc.w    32,32,32,32,32,32,32,32,32,32,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
    dc.w    0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,32,32,32,32,32,32,32,32,32
    dc.w    32,32,32,32,32,64,64,64,64,64,64,64,64,64,64,64,96,96,96,96,96,96,96,96,96,128,128,128,128,128,128,128
    dc.w    128,160,160,160,160,160,160,160,160,192,192,192,192,192,192,224,224,224,224,224,224,224,256,256,256,256,256,256,288,288,288,288
    dc.w    288,288,320,320,320,320,320,320,352,352,352,352,352,384,384,384,384,384,384,416,416,416,416,416,448,448,448,448,448,448,480,480
    dc.w    480,480,480,512,512,512,512,512,512,544,544,544,544,544,576,576,576,576,576,576,608,608,608,608,608,640,640,640,640,640,640,672
    dc.w    672,672,672,672,672,704,704,704,704,704,704,736,736,736,736,736,736,736,768,768,768,768,768,768,800,800,800,800,800,800,800,800
    dc.w    832,832,832,832,832,832,832,832,864,864,864,864,864,864,864,864,864,896,896,896,896,896,896,896,896,896,896,896,928,928,928,928
    dc.w    928,928,928,928,928,928,928,928,928,928,928,960,960,960,960,960,960,960,960,960,960,960,960,960,960,960,960,960,960,960,960,960
    dc.w    960,960,960,960,960,960,960,960,960,960,960,960,960,960,960,960,960,960,960,960,960,960,928,928,928,928,928,928,928,928,928,928
    dc.w    928,928,928,928,928,896,896,896,896,896,896,896,896,896,896,896,864,864,864,864,864,864,864,864,864,832,832,832,832,832,832,832
    dc.w    832,800,800,800,800,800,800,800,800,768,768,768,768,768,768,736,736,736,736,736,736,736,704,704,704,704,704,704,672,672,672,672
    dc.w    672,672,640,640,640,640,640,640,608,608,608,608,608,576,576,576,576,576,576,544,544,544,544,544,512,512,512,512,512,512,480,480
    dc.w    480,480,480,448,448,448,448,448,448,416,416,416,416,416,384,384,384,384,384,384,352,352,352,352,352,320,320,320,320,320,320,288
    dc.w    288,288,288,288,288,256,256,256,256,256,256,224,224,224,224,224,224,224,192,192,192,192,192,192,160,160,160,160,160,160,160,160
    dc.w    128,128,128,128,128,128,128,128,96,96,96,96,96,96,96,96,96,64,64,64,64,64,64,64,64,64,64,64,32,32,32,32
    dc.w    32,32,32,32,32,32,32,32,32,32,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
    dc.w    0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,32,32,32,32,32,32,32,32,32
    dc.w    32,32,32,32,32,64,64,64,64,64,64,64,64,64,64,64,96,96,96,96,96,96,96,96,96,128,128,128,128,128,128,128
    dc.w    128,160,160,160,160,160,160,160,160,192,192,192,192,192,192,224,224,224,224,224,224,224,256,256,256,256,256,256,288,288,288,288
    dc.w    288,288,320,320,320,320,320,320,352,352,352,352,352,384,384,384,384,384,384,416,416,416,416,416,448,448,448,448,448,448,480,480
    dc.w    480,480,480,512,512,512,512,512,512,544,544,544,544,544,576,576,576,576,576,576,608,608,608,608,608,640,640,640,640,640,640,672
    dc.w    672,672,672,672,672,704,704,704,704,704,704,736,736,736,736,736,736,736,768,768,768,768,768,768,800,800,800,800,800,800,800,800
    dc.w    832,832,832,832,832,832,832,832,864,864,864,864,864,864,864,864,864,896,896,896,896,896,896,896,896,896,896,896,928,928,928,928
    dc.w    928,928,928,928,928,928,928,928,928,928,928,960,960,960,960,960,960,960,960,960,960,960,960,960,960,960,960,960,960,960,960,960
    dc.w    960,960,960,960,960,960,960,960,960,960,960,960,960,960,960,960,960,960,960,960,960,960,928,928,928,928,928,928,928,928,928,928
    dc.w    928,928,928,928,928,896,896,896,896,896,896,896,896,896,896,896,864,864,864,864,864,864,864,864,864,832,832,832,832,832,832,832
    dc.w    832,800,800,800,800,800,800,800,800,768,768,768,768,768,768,736,736,736,736,736,736,736,704,704,704,704,704,704,672,672,672,672
    dc.w    672,672,640,640,640,640,640,640,608,608,608,608,608,576,576,576,576,576,576,544,544,544,544,544,512,512,512,512,512,512,480,480
    dc.w    480,480,480,448,448,448,448,448,448,416,416,416,416,416,384,384,384,384,384,384,352,352,352,352,352,320,320,320,320,320,320,288
    dc.w    288,288,288,288,288,256,256,256,256,256,256,224,224,224,224,224,224,224,192,192,192,192,192,192,160,160,160,160,160,160,160,160
    dc.w    128,128,128,128,128,128,128,128,96,96,96,96,96,96,96,96,96,64,64,64,64,64,64,64,64,64,64,64,32,32,32,32
    dc.w    32,32,32,32,32,32,32,32,32,32,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
    dc.w    0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,32,32,32,32,32,32,32,32,32
    dc.w    32,32,32,32,32,64,64,64,64,64,64,64,64,64,64,64,96,96,96,96,96,96,96,96,96,128,128,128,128,128,128,128
    dc.w    128,160,160,160,160,160,160,160,160,192,192,192,192,192,192,224,224,224,224,224,224,224,256,256,256,256,256,256,288,288,288,288
    dc.w    288,288,320,320,320,320,320,320,352,352,352,352,352,384,384,384,384,384,384,416,416,416,416,416,448,448,448,448,448,448,480,480
    dc.w    480,480,480,512,512,512,512,512,512,544,544,544,544,544,576,576,576,576,576,576,608,608,608,608,608,640,640,640,640,640,640,672
    dc.w    672,672,672,672,672,704,704,704,704,704,704,736,736,736,736,736,736,736,768,768,768,768,768,768,800,800,800,800,800,800,800,800
    dc.w    832,832,832,832,832,832,832,832,864,864,864,864,864,864,864,864,864,896,896,896,896,896,896,896,896,896,896,896,928,928,928,928
    dc.w    928,928,928,928,928,928,928,928,928,928,928,960,960,960,960,960,960,960,960,960,960,960,960,960,960,960,960,960,960,960,960,960
    dc.w    960,960,960,960,960,960,960,960,960,960,960,960,960,960,960,960,960,960,960,960,960,960,928,928,928,928,928,928,928,928,928,928
    dc.w    928,928,928,928,928,896,896,896,896,896,896,896,896,896,896,896,864,864,864,864,864,864,864,864,864,832,832,832,832,832,832,832
    dc.w    832,800,800,800,800,800,800,800,800,768,768,768,768,768,768,736,736,736,736,736,736,736,704,704,704,704,704,704,672,672,672,672
    dc.w    672,672,640,640,640,640,640,640,608,608,608,608,608,576,576,576,576,576,576,544,544,544,544,544,512,512,512,512,512,512,480,480
    dc.w    480,480,480,448,448,448,448,448,448,416,416,416,416,416,384,384,384,384,384,384,352,352,352,352,352,320,320,320,320,320,320,288
    dc.w    288,288,288,288,288,256,256,256,256,256,256,224,224,224,224,224,224,224,192,192,192,192,192,192,160,160,160,160,160,160,160,160
    dc.w    128,128,128,128,128,128,128,128,96,96,96,96,96,96,96,96,96,64,64,64,64,64,64,64,64,64,64,64,32,32,32,32
    dc.w    32,32,32,32,32,32,32,32,32,32,32,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
    dc.w    0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,32,32,32,32,32,32,32,32,32,32
    dc.w    32,32,32,32,32,64,64,64,64,64,64,64,64,64,64,64,96,96,96,96,96,96,96,96,96,128,128,128,128,128,128,128
    dc.w    128,160,160,160,160,160,160,160,160,192,192,192,192,192,192,224,224,224,224,224,224,224,256,256,256,256,256,256,288,288,288,288
    dc.w    288,288,320,320,320,320,320,320,352,352,352,352,352,384,384,384,384,384,384,416,416,416,416,416,448,448,448,448,448,448,480,480

Lava_a: dc.l 0
Lava_b: dc.l 0
     
 
  SECTION BSS

FadePalette:  ds.w 16*33
